## stellarium 24.2

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 3.16)
# CMake 3.20+ is required if x-compiling for Windows on ARM
MESSAGE(STATUS "Found CMake ${CMAKE_VERSION}")

# Fix behavior of CMAKE_CXX_STANDARD and CMAKE_C_STANDARD when targeting macOS.
IF(POLICY CMP0025)
     CMAKE_POLICY(SET CMP0025 NEW)
ENDIF()
# Potential dangerous comparison of variables. Details: https://cmake.org/cmake/help/v3.1/policy/CMP0054.html
IF(POLICY CMP0054)
     CMAKE_POLICY(SET CMP0054 NEW)
ENDIF()
IF(POLICY CMP0071)
     CMAKE_POLICY(SET CMP0071 NEW)
ENDIF()

# warn about deprecated stuff so that we may try fixing it
SET(CMAKE_WARN_DEPRECATED 1)

SET_PROPERTY(GLOBAL PROPERTY USE_FOLDERS ON)

########### Project name ###########
PROJECT(Stellarium C CXX)

SET(STELLARIUM_RELEASE_BUILD 1 CACHE BOOL "Set 1 to build as an official release (0 for development snapshots).")

########### Detect Qt version
SET(ENABLE_QT6 1 CACHE BOOL "Whether to try building with Qt6. If Qt6 is not found, Qt5 will be used.")
IF(ENABLE_QT6)
    FIND_PACKAGE(Qt6 COMPONENTS Core QUIET)
ENDIF()
if (NOT Qt6_FOUND)
    FIND_PACKAGE(Qt5 REQUIRED COMPONENTS Core)
ENDIF()

# Activate this to error on all things deprecated in 5.15
#add_compile_definitions("QT_DISABLE_DEPRECATED_BEFORE=0x050F00")

# Version of Stellarium has format YY.V.YD, where:
# -- YY (MAJOR) - two last digits of the year of release
# -- V  (MINOR) - version of the release (0 is used before first release)
# -- YD (PATCH) - 0 for releases and the day of the current year for snapshots
# Example: first release in year 2023 has version 23.1.0 and short (public) version 23.1, series 23.0
# Note: Use integer versions instead of strings for easier handling if required
SET(STELLARIUM_MAJOR 24)
# Number of the release (0 is used before first release)
SET(STELLARIUM_MINOR 2)
IF(STELLARIUM_RELEASE_BUILD)
    ADD_DEFINITIONS(-DSTELLARIUM_RELEASE_BUILD)
    SET(CMAKE_BUILD_TYPE Release)
    SET(STELLARIUM_PATCH 0)
ELSE()
    ########### Get revision number for non-release builds ###########
    STRING(TIMESTAMP CDNUMBER "%j")
    MATH(EXPR STELLARIUM_PATCH_DIGIT "${CDNUMBER} + 0" OUTPUT_FORMAT DECIMAL)
    SET(STELLARIUM_PATCH ${STELLARIUM_PATCH_DIGIT})
ENDIF()
# Use integer versions instead of strings for easier handling if required
ADD_DEFINITIONS(
     -DSTELLARIUM_MAJOR=${STELLARIUM_MAJOR}
     -DSTELLARIUM_MINOR=${STELLARIUM_MINOR}
     -DSTELLARIUM_PATCH=${STELLARIUM_PATCH}
)
SET(VERSION "${STELLARIUM_MAJOR}.${STELLARIUM_MINOR}.${STELLARIUM_PATCH}")
SET(STELLARIUM_SERIES "${STELLARIUM_MAJOR}.0")
SET(STELLARIUM_PUBLIC_VERSION "${STELLARIUM_MAJOR}.${STELLARIUM_MINOR}")
SET(PACKAGE stellarium)
STRING(TIMESTAMP CURRENTYEAR "%Y")
SET(COPYRIGHT_YEARS "2000-${CURRENTYEAR}")

SET(STELLARIUM_URL "https://stellarium.org/")
ADD_DEFINITIONS(-DSTELLARIUM_URL="${STELLARIUM_URL}")

# remembering the name and the version of compiler for StelLogger
SET(STELLARIUM_COMPILER "${CMAKE_CXX_COMPILER_ID} ${CMAKE_CXX_COMPILER_VERSION}")
ADD_DEFINITIONS(-DSTELLARIUM_COMPILER="${STELLARIUM_COMPILER}")

# The line below is copied from src/gui/HelpDialog.cpp file
SET(STELLARIUM_COPYRIGHT "Copyright (C) ${COPYRIGHT_YEARS} ${PROJECT_NAME} Developers")
# The line below is copied from src/main.cpp file
#SET(STELLARIUM_COPYRIGHT "Copyright (C) ${COPYRIGHT_YEARS} Fabien Chereau et al.")
ADD_DEFINITIONS(-DSTELLARIUM_COPYRIGHT="${STELLARIUM_COPYRIGHT}")

# Define URL for usage within program (feedback URL for plug-ins)
SET(STELLARIUM_DEV_URL "https://github.com/Stellarium/stellarium")
ADD_DEFINITIONS(-DSTELLARIUM_DEV_URL="${STELLARIUM_DEV_URL}")

SET(PACKAGE_VERSION "${VERSION}")
ADD_DEFINITIONS(-DPACKAGE_VERSION="${PACKAGE_VERSION}")
ADD_DEFINITIONS(-DCOPYRIGHT_YEARS="${COPYRIGHT_YEARS}")
ADD_DEFINITIONS(-DSTELLARIUM_SOURCE_DIR="${PROJECT_SOURCE_DIR}")
ADD_DEFINITIONS(-DSTELLARIUM_PUBLIC_VERSION="${STELLARIUM_PUBLIC_VERSION}")
ADD_DEFINITIONS(-DSTELLARIUM_SERIES="${STELLARIUM_SERIES}")

# Qt 5.15+ is preferred as it provides version-less CMake functions (QT_WRAP_UI etc.)
IF(Qt6_FOUND)
     SET(MINIMAL_QT_VERSION "6.2.0")
     IF(NOT DEFINED QT_VERSION_MAJOR)
         SET(QT_VERSION_MAJOR 6)
     ENDIF()
ELSE()
     SET(MINIMAL_QT_VERSION "5.12.0")
     IF(NOT DEFINED QT_VERSION_MAJOR)
         SET(QT_VERSION_MAJOR 5)
     ENDIF()
ENDIF()
# TODO: Check real minimal supported version of GPSD API
SET(MINIMAL_GPS_API_VERSION "6.0")

### Define minimal version for Windows
# Use installer for checking minimum requirements
# Stellarium/MSVC require Windows 7 (6.1) for work
# Details: http://www.jrsoftware.org/ishelp/index.php?topic=winvernotes
IF(Qt6_FOUND)
     SET(ISS_MIN_WIN_VERSION "10.0")
ELSE()
     SET(ISS_MIN_WIN_VERSION "6.1")
ENDIF()
# Define required version for MSVC
# Details: https://docs.microsoft.com/ru-ru/windows/win32/winprog/using-the-windows-headers
IF(Qt6_FOUND)
     SET(MIN_WIN_VERSION "0x0A00")
ELSE()
     SET(MIN_WIN_VERSION "0x0601")
ENDIF()

# Use customized cmake macros
SET(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake/modules)
INCLUDE(CPM)

# Show platform info
MESSAGE(STATUS "Platform: ${CMAKE_SYSTEM} (${CMAKE_SYSTEM_PROCESSOR})")

########### Main global variables ###########
SET(ENABLE_TESTING 0 CACHE BOOL "Define whether the unit tests should be activated.")
SET(ENABLE_LTO 0 CACHE BOOL "Define whether the Link Time Optimization should be activated.")
SET(ENABLE_PCH 1 CACHE BOOL "Define whether to use precompiled headers.")

IF(NOT CMAKE_BUILD_TYPE)
     SET(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build, options are: None Debug GProf Valgrind ASan UBSan Release RelWithDebInfo MinSizeRel." FORCE)
ENDIF()

IF(${CMAKE_BUILD_TYPE} MATCHES "Debug")
     IF(CMAKE_COMPILER_IS_GNUCXX)
          INCLUDE(CodeCoverage)
          IF(LCOV_PATH AND ENABLE_TESTING)
               APPEND_COVERAGE_COMPILER_FLAGS()
               MESSAGE(STATUS "Found lcov ${LCOV_PATH} (enable coverage support)")
               SETUP_TARGET_FOR_COVERAGE_LCOV(
                    NAME coverage 
                    EXECUTABLE ctest -j ${PROCESSOR_COUNT} 
                    DEPENDENCIES buildTests
               )
          ENDIF()
     ENDIF()
ENDIF()

IF(STELLARIUM_RELEASE_BUILD)
     SET(ISS_PACKAGE_VERSION "${STELLARIUM_PUBLIC_VERSION}")
     SET(STELLARIUM_BUIDING_VERSION "${STELLARIUM_PUBLIC_VERSION}")
ELSE()
     SET(STELLARIUM_SERIES "head")
     FIND_PACKAGE(Git QUIET)
     IF(Git_FOUND)
          MESSAGE(STATUS "Found Git ${GIT_VERSION_STRING}")
          # get the name of current branch
          EXECUTE_PROCESS(COMMAND ${GIT_EXECUTABLE} rev-parse --abbrev-ref HEAD WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} TIMEOUT 30 OUTPUT_VARIABLE GIT_BRANCH OUTPUT_STRIP_TRAILING_WHITESPACE ERROR_VARIABLE GIT_ERROR)
          # get the hash of latest commit
          EXECUTE_PROCESS(COMMAND ${GIT_EXECUTABLE} log -1 --pretty=format:%h WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} TIMEOUT 30 OUTPUT_VARIABLE GIT_REVISION OUTPUT_STRIP_TRAILING_WHITESPACE ERROR_VARIABLE GIT_ERROR)
          # get the name of latest annotated tag
          EXECUTE_PROCESS(COMMAND ${GIT_EXECUTABLE} describe --tags --abbrev=0 WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} TIMEOUT 30 OUTPUT_VARIABLE GIT_TAGS OUTPUT_STRIP_TRAILING_WHITESPACE ERROR_VARIABLE GIT_ERROR)
	  IF(GIT_REVISION)
               # Let's use short hash in all cases
               STRING(SUBSTRING ${GIT_REVISION} 0 7 REVISION)               
	       ADD_DEFINITIONS(-DGIT_REVISION="${REVISION}")
               ADD_DEFINITIONS(-DGIT_BRANCH="${GIT_BRANCH}")
	  ENDIF()
     ELSE()
          STRING(TIMESTAMP TODAY "%j%H%M")
          SET(REVISION "${TODAY}")
	  ADD_DEFINITIONS(-DGIT_REVISION="${TODAY}")
          ADD_DEFINITIONS(-DGIT_BRANCH="tarball")
     ENDIF()
     SET(ISS_PACKAGE_VERSION "${STELLARIUM_PUBLIC_VERSION}-${REVISION}")
     SET(STELLARIUM_BUIDING_VERSION "${STELLARIUM_PUBLIC_VERSION}+")
ENDIF()
MESSAGE(STATUS "Building ${PROJECT_NAME} ${STELLARIUM_BUIDING_VERSION} (v${PACKAGE_VERSION}; Mode: ${CMAKE_BUILD_TYPE})")
ADD_DEFINITIONS(-DSTELLARIUM_BUIDING_VERSION="${STELLARIUM_BUIDING_VERSION}")

# Write version and series of Stellarium to Stellarium User Guide
CONFIGURE_FILE(${PROJECT_SOURCE_DIR}/cmake/version.tex.cmake ${PROJECT_SOURCE_DIR}/guide/version.tex @ONLY NEWLINE_STYLE LF)

SET(OPENGL_DEBUG_LOGGING 0 CACHE BOOL "Enable to log OpenGL information using the GL_KHR_debug extension/QOpenGLLogger")
IF(OPENGL_DEBUG_LOGGING)
     ADD_DEFINITIONS(-DOPENGL_DEBUG_LOGGING)
     # This enables logging of QOpenGLFunctions through forced glGetError after each call
     ADD_DEFINITIONS(-DQ_ENABLE_OPENGL_FUNCTIONS_DEBUG)
ENDIF()

# Use ccache if possible
IF(NOT WIN32)
     FIND_PROGRAM(CCACHE_PROGRAM ccache)
     IF(CCACHE_PROGRAM)
          MESSAGE(STATUS "Found ccache ${CCACHE_PROGRAM}")
          SET_PROPERTY(GLOBAL PROPERTY RULE_LAUNCH_COMPILE "${CCACHE_PROGRAM}")
     ENDIF()
ENDIF()

# Add gprof build options if necessary.  Note gmon.out will be created in working directory when Stellarium is executed
IF(${CMAKE_BUILD_TYPE} MATCHES "GProf")
     SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fprofile-arcs")
     SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fprofile-arcs")
     SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -pg")
ENDIF()

# Add valgrind build options if necessary
IF(${CMAKE_BUILD_TYPE} MATCHES "Valgrind")
     SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -O0 -g")
     SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O0 -g")
ENDIF()

# Add ASan (AddressSanitizer) build options if necessary
# Details: https://github.com/google/sanitizers/wiki/AddressSanitizer
#          https://docs.microsoft.com/ru-ru/cpp/build/reference/fsanitize?view=msvc-150
IF(${CMAKE_BUILD_TYPE} MATCHES "ASan")
     IF(MSVC)
          SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /fsanitize=address")
          SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /fsanitize=address")
     ELSE()
          SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=address -O1 -fno-omit-frame-pointer -g")
          SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address -O1 -fno-omit-frame-pointer -g")
     ENDIF()
ENDIF()

# Add UBSan (UndefinedBehaviorSanitizer) build options if necessary
# Details: https://clang.llvm.org/docs/UndefinedBehaviorSanitizer.html
IF(${CMAKE_BUILD_TYPE} MATCHES "UBSan")
     SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=undefined -g")
     SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=undefined -g")
ENDIF()

# Add Fuzzer (Fuzzer Sanitizer) build options if necessary
# Details: https://llvm.org/docs/LibFuzzer.html
#          https://docs.microsoft.com/ru-ru/cpp/build/reference/fsanitize?view=msvc-150
IF(${CMAKE_BUILD_TYPE} MATCHES "Fuzzer")
     IF(MSVC)
          SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /fsanitize=fuzzer")
          SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /fsanitize=fuzzer")
     ELSE()
          SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=fuzzer -O1 -g")
          SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=fuzzer -O1 -g")
     ENDIF()
ENDIF()

IF(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
     SET(APPLE 1)
     SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++")
     # share data location:
     SET(SDATALOC "Resources")
ELSE()
     IF(HAIKU)
	  SET(SDATAPREFIX "data")
     ELSE()
	  SET(SDATAPREFIX "share")
     ENDIF()
     # share data location:
     SET(SDATALOC "${SDATAPREFIX}/${PACKAGE}")
ENDIF()

IF(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_COMPILER_IS_GNUCC)
     IF(WIN32)
        # The stars structs rely on gnu gcc packing of bit-fields.
        SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mno-ms-bitfields")
     ENDIF()
     SET(GCC_VERSION "${CMAKE_CXX_COMPILER_VERSION}")
ELSE()
     SET(GCC_VERSION "0.0")
ENDIF()

# _USE_MATH_DEFINES enables use of math constants like M_PI,
# which are by default disabled in standard C++ mode (like std=c++11 instead of std=gnu11)
ADD_DEFINITIONS(-D_USE_MATH_DEFINES)

# flags shared for gcc-like compilers (also MinGW/Clang)
# Qt 5.7 requires C++11 support
SET(STEL_GCC_C_FLAGS "-Wall -Wextra -Wno-unused-parameter -Wno-unknown-pragmas")

=== src/CMakeLists.txt ===
#add our external dependencies first
add_subdirectory(external)

IF(ENABLE_SPOUT)
    SET(spout_SRCS
     external/SpoutLibrary.h
     core/SpoutSender.hpp
     core/SpoutSender.cpp
	 )
ENDIF()

SET(stellarium_lib_SRCS
     core/BlueNoiseTriangleRemapped.hpp
     core/StelSRGB.hpp
     core/StelSRGB.cpp
     core/Dithering.hpp
     core/Dithering.cpp
     core/SaturationShader.hpp
     core/StelAudioMgr.hpp
     core/StelAudioMgr.cpp
     core/StelVideoMgr.hpp
     core/StelVideoMgr.cpp
     core/StelGeodesicGrid.cpp
     core/StelGeodesicGrid.hpp
     core/StelMovementMgr.cpp
     core/StelMovementMgr.hpp
     core/StelObserver.cpp
     core/StelObserver.hpp
     core/StelLocation.hpp
     core/StelLocation.cpp
     core/StelLocationMgr.hpp
     core/StelLocationMgr_p.hpp
     core/StelLocationMgr.cpp
     core/StelProjector.cpp
     core/StelProjector.hpp
     core/StelProjectorClasses.cpp
     core/StelProjectorClasses.hpp
     core/StelProjectorType.hpp
     core/StelSkyDrawer.cpp
     core/StelSkyDrawer.hpp
     core/StelPainter.hpp
     core/StelPainter.cpp
     core/MultiLevelJsonBase.hpp
     core/MultiLevelJsonBase.cpp
     core/StelSkyImageTile.hpp
     core/StelSkyImageTile.cpp
     core/SolarEclipseComputer.hpp
     core/SolarEclipseComputer.cpp
     core/SphericMirrorCalculator.cpp
     core/SphericMirrorCalculator.hpp
     core/StelApp.cpp
     core/StelApp.hpp
     core/StelCore.cpp
     core/StelCore.hpp
     core/StelFileMgr.cpp
     core/StelFileMgr.hpp
     core/StelLocaleMgr.cpp
     core/StelLocaleMgr.hpp
     core/StelModule.cpp
     core/StelModule.hpp
     core/StelModuleMgr.cpp
     core/StelModuleMgr.hpp
     core/StelObject.cpp
     core/StelObject.hpp
     core/StelObjectMgr.cpp
     core/StelObjectMgr.hpp
     core/StelObjectModule.cpp
     core/StelObjectModule.hpp
     core/StelObjectType.hpp
     core/StelOpenGL.cpp
     core/StelOpenGL.hpp
     core/StelPluginInterface.hpp
     core/StelRegionObject.hpp
     core/StelSkyCultureMgr.cpp
     core/StelSkyCultureMgr.hpp
     core/StelTextureMgr.cpp
     core/StelTextureMgr.hpp
     core/StelTexture.cpp
     core/StelTexture.hpp
     core/StelTextureTypes.hpp
     core/StelToneReproducer.cpp
     core/StelToneReproducer.hpp
     core/StelSkyLayerMgr.cpp
     core/StelSkyLayerMgr.hpp
     core/StelSkyLayer.hpp
     core/StelSkyLayer.cpp
     core/StelFader.hpp
     core/StelSphereGeometry.cpp
     core/StelSphereGeometry.hpp
     core/OctahedronPolygon.cpp
     core/OctahedronPolygon.hpp
     core/StelIniParser.cpp
     core/StelIniParser.hpp
     core/StelUtils.cpp
     core/StelUtils.hpp
     core/StelTranslator.cpp
     core/StelTranslator.hpp
     core/VecMath.hpp
     core/VecMath.cpp
     core/StelJsonParser.hpp
     core/StelJsonParser.cpp
     core/SimbadSearcher.hpp
     core/SimbadSearcher.cpp
     core/StelSphericalIndex.hpp
     core/StelSphericalIndex.cpp
     core/StelVertexArray.hpp
     core/StelVertexArray.cpp
     core/StelGuiBase.hpp
     core/StelGuiBase.cpp
     core/StelViewportEffect.hpp
     core/StelViewportEffect.cpp
     core/TrailGroup.hpp
     core/TrailGroup.cpp
     core/RefractionExtinction.hpp
     core/RefractionExtinction.cpp
     core/StelToast.hpp
     core/StelToast.cpp
     core/StelToastGrid.hpp
     core/StelToastGrid.cpp
     core/StelActionMgr.hpp
     core/StelActionMgr.cpp
     core/StelProgressController.hpp
     core/StelPropertyMgr.hpp
     core/StelPropertyMgr.cpp
     core/StelOBJ.hpp
     core/StelOBJ.cpp
     core/GeomMath.hpp
     core/GeomMath.cpp
     core/StelOpenGLArray.hpp
     core/StelOpenGLArray.cpp
     core/StelHips.hpp
     core/StelHips.cpp
     core/TextureAverageComputer.hpp
     core/TextureAverageComputer.cpp

     ${spout_SRCS}

     core/planetsephems/calc_interpolated_elements.c
     core/planetsephems/calc_interpolated_elements.h
     core/planetsephems/elliptic_to_rectangular.c
     core/planetsephems/elliptic_to_rectangular.h
     core/planetsephems/elp82b.c
     core/planetsephems/elp82b.h
     core/planetsephems/gust86.c
     core/planetsephems/gust86.h
     core/planetsephems/l12.c
     core/planetsephems/l12.h
     core/planetsephems/marssat.c
     core/planetsephems/marssat.h
     core/planetsephems/pluto.c
     core/planetsephems/pluto.h
     core/planetsephems/precession.c
     core/planetsephems/precession.h
     core/planetsephems/sidereal_time.c
     core/planetsephems/sidereal_time.h
     core/planetsephems/jpl_int.h
     core/planetsephems/jpleph.h
     core/planetsephems/jpleph.cpp
     core/planetsephems/EphemWrapper.cpp
     core/planetsephems/EphemWrapper.hpp
     core/planetsephems/tass17.c
     core/planetsephems/tass17.h
     core/planetsephems/vsop87.c
     core/planetsephems/vsop87.h
     core/planetsephems/de430.cpp
     core/planetsephems/de430.hpp
     core/planetsephems/de431.cpp
     core/planetsephems/de431.hpp
     core/planetsephems/de440.cpp
     core/planetsephems/de440.hpp
     core/planetsephems/de441.cpp
     core/planetsephems/de441.hpp
     core/planetsephems/htc20b.c
     core/planetsephems/htc20b.h
     core/modules/AtmospherePreetham.cpp
     core/modules/AtmospherePreetham.hpp
     core/modules/AtmosphereShowMySky.cpp
     core/modules/AtmosphereShowMySky.hpp
     core/modules/Atmosphere.hpp
     core/modules/Asterism.cpp
     core/modules/Asterism.hpp
     core/modules/AsterismMgr.cpp
     core/modules/AsterismMgr.hpp
     core/modules/Constellation.cpp
     core/modules/Constellation.hpp
     core/modules/ConstellationMgr.cpp
     core/modules/ConstellationMgr.hpp
     core/modules/CustomObject.cpp
     core/modules/CustomObject.hpp
     core/modules/CustomObjectMgr.cpp
     core/modules/CustomObjectMgr.hpp
     core/modules/HighlightMgr.cpp
     core/modules/HighlightMgr.hpp
     core/modules/GridLinesMgr.cpp
     core/modules/GridLinesMgr.hpp
     core/modules/HipsMgr.hpp
     core/modules/HipsMgr.cpp
     core/modules/LabelMgr.hpp
     core/modules/LabelMgr.cpp
     core/modules/MarkerMgr.hpp
     core/modules/MarkerMgr.cpp
     core/modules/Landscape.cpp
     core/modules/Landscape.hpp
     core/modules/LandscapeMgr.cpp
     core/modules/LandscapeMgr.hpp
     core/modules/Meteor.cpp
     core/modules/Meteor.hpp
     core/modules/SporadicMeteor.cpp
     core/modules/SporadicMeteor.hpp
     core/modules/SporadicMeteorMgr.cpp
     core/modules/SporadicMeteorMgr.hpp
     core/modules/MilkyWay.cpp
     core/modules/MilkyWay.hpp
     core/modules/Nebula.cpp
     core/modules/Nebula.hpp
     core/modules/NebulaList.hpp
     core/modules/NebulaMgr.cpp
     core/modules/NebulaMgr.hpp
     core/modules/Orbit.cpp
     core/modules/Orbit.hpp
     core/modules/Planet.cpp
     core/modules/Planet.hpp
     core/modules/RotationElements.cpp
     core/modules/RotationElements.hpp
     core/modules/MinorPlanet.cpp
     core/modules/MinorPlanet.hpp
     core/modules/Comet.cpp
     core/modules/Comet.hpp
     core/modules/Skybright.cpp
     core/modules/Skybright.hpp
     core/modules/Skylight.cpp
     core/modules/Skylight.hpp
     core/modules/SolarSystem.cpp
     core/modules/SolarSystem.hpp
     core/modules/NomenclatureItem.cpp
     core/modules/NomenclatureItem.hpp
     core/modules/NomenclatureMgr.cpp
     core/modules/NomenclatureMgr.hpp
     core/modules/Solve.hpp
     core/modules/Star.cpp
     core/modules/Star.hpp
     core/modules/StarMgr.cpp
     core/modules/StarMgr.hpp
     core/modules/StarWrapper.cpp
     core/modules/StarWrapper.hpp
     core/modules/ToastMgr.hpp
     core/modules/ToastMgr.cpp
     core/modules/ZoneArray.cpp
     core/modules/ZodiacalLight.hpp
     core/modules/ZodiacalLight.cpp
     core/modules/ZoneArray.hpp
     core/modules/ZoneData.hpp
     core/modules/SpecialMarkersMgr.cpp
     core/modules/SpecialMarkersMgr.hpp
     core/modules/SpecificTimeMgr.cpp
     core/modules/SpecificTimeMgr.hpp
     StelMainView.hpp
     StelMainView.cpp
     StelSplashScreen.hpp
     StelSplashScreen.cpp
     StelLogger.hpp
     StelLogger.cpp
     CLIProcessor.hpp
     CLIProcessor.cpp
     translations.h
     translations_regions.h
)

IF(ENABLE_PCH)
     SET(stellarium_lib_SRCS ${stellarium_lib_SRCS}
         stelMain_pch.hpp
     )
ENDIF(ENABLE_PCH)

IF(ENABLE_SCRIPTING)
     SET(stellarium_lib_SRCS ${stellarium_lib_SRCS}
          scripting/StelScriptOutput.hpp
          scripting/StelScriptOutput.cpp
          scripting/V3d.cpp
          scripting/V3d.hpp
          scripting/StelScriptMgr.cpp
          scripting/StelScriptMgr.hpp
          scripting/ScreenImageMgr.hpp
          scripting/ScreenImageMgr.cpp
          scripting/StelMainScriptAPI.cpp
          scripting/StelMainScriptAPI.hpp
          scripting/StelMainScriptAPIProxy.cpp
          scripting/StelMainScriptAPIProxy.hpp
     )
ENDIF()

SET(stellarium_exe_SRCS main.cpp)

################# compiles resources files ############
SET(stellarium_RES ${CMAKE_SOURCE_DIR}/data/mainRes.qrc)
IF(${QT_VERSION_MAJOR} EQUAL "5")
     QT5_ADD_RESOURCES(stellarium_RES_CXX ${stellarium_RES})
ELSE()
     QT_ADD_RESOURCES(stellarium_RES_CXX ${stellarium_RES})
ENDIF()
#############################################################################################
############################# Standard GUI plugin compilation ###############################
#############################################################################################
IF(STELLARIUM_GUI_MODE STREQUAL "Standard")
     SET(stellarium_gui_SRCS
          gui/StelGui.hpp
          gui/StelGui.cpp
          gui/SkyGui.hpp
          gui/SkyGui.cpp
          gui/StelStyle.hpp
          gui/StelGuiItems.hpp
          gui/StelGuiItems.cpp
          gui/HelpDialog.hpp
          gui/HelpDialog.cpp
          gui/ShortcutLineEdit.hpp
          gui/ShortcutLineEdit.cpp
          gui/ShortcutsDialog.hpp
          gui/ShortcutsDialog.cpp
          gui/Dialog.hpp
          gui/Dialog.cpp
          gui/MapWidget.hpp
          gui/MapWidget.cpp
          gui/AngleSpinBox.hpp
          gui/AngleSpinBox.cpp
          gui/LocationDialog.hpp
          gui/LocationDialog.cpp
          gui/DateTimeDialog.hpp
          gui/DateTimeDialog.cpp
          gui/ViewDialog.hpp
          gui/ViewDialog.cpp
          gui/LightPollutionWidget.hpp
          gui/LightPollutionWidget.cpp
          gui/LogarithmicSpinBox.hpp
          gui/LogarithmicSpinBox.cpp
          gui/SearchDialog.hpp
          gui/SearchDialog.cpp
          gui/ConfigurationDialog.hpp
          gui/ConfigurationDialog.cpp
          gui/AddRemoveLandscapesDialog.hpp
          gui/AddRemoveLandscapesDialog.cpp
          gui/AtmosphereDialog.hpp
          gui/AtmosphereDialog.cpp
          gui/ConfigureDSOColorsDialog.hpp
          gui/ConfigureDSOColorsDialog.cpp
          gui/ConfigureOrbitColorsDialog.hpp
          gui/ConfigureOrbitColorsDialog.cpp
          gui/GreatRedSpotDialog.hpp
          gui/GreatRedSpotDialog.cpp
          gui/CustomDeltaTEquationDialog.hpp
          gui/CustomDeltaTEquationDialog.cpp
          gui/ConfigureScreenshotsDialog.hpp
          gui/ConfigureScreenshotsDialog.cpp
          gui/AstroCalcDialog.hpp
          gui/AstroCalcDialog.cpp
          gui/AstroCalcExtraEphemerisDialog.hpp
          gui/AstroCalcExtraEphemerisDialog.cpp
          gui/AstroCalcCustomStepsDialog.hpp
          gui/AstroCalcCustomStepsDialog.cpp
          gui/AstroCalcChart.hpp
          gui/AstroCalcChart.cpp
          gui/ObsListDialog.hpp
          gui/ObsListDialog.cpp
          gui/StelDialog.hpp
          gui/StelDialog_p.hpp
          gui/StelDialog.cpp
          gui/StelDialogSeparate.hpp
          gui/StelDialogSeparate.cpp
          gui/TonemappingDialog.hpp
          gui/TonemappingDialog.cpp
          gui/SkylightDialog.hpp
          gui/SkylightDialog.cpp
          gui/ContributorsList.hpp
          gui/StelCloseButton.hpp
          gui/StelCloseButton.cpp
          gui/ColorButton.hpp
          gui/ColorButton.cpp
          gui/ExternalStepSpinBox.hpp
     )

=== plugins/Exoplanets/CMakeLists.txt ===
SET(EXOPLANETS_PLUGIN_MAJOR "0")
SET(EXOPLANETS_PLUGIN_MINOR "6")
SET(EXOPLANETS_PLUGIN_PATCH "2")
SET(EXOPLANETS_VERSION "${EXOPLANETS_PLUGIN_MAJOR}.${EXOPLANETS_PLUGIN_MINOR}.${EXOPLANETS_PLUGIN_PATCH}")

ADD_DEFINITIONS(-DEXOPLANETS_PLUGIN_VERSION="${EXOPLANETS_VERSION}")
ADD_DEFINITIONS(-DEXOPLANETS_PLUGIN_LICENSE="GNU GPLv2 or later")

ADD_SUBDIRECTORY( src )

=== plugins/NavStars/CMakeLists.txt ===
SET(NS_MAJOR 0)
SET(NS_MINOR 4)
SET(NS_PATCH 7)
SET(NS_VERSION "${NS_MAJOR}.${NS_MINOR}.${NS_PATCH}")

ADD_DEFINITIONS(-DNAVSTARS_PLUGIN_VERSION="${NS_VERSION}")
ADD_DEFINITIONS(-DNAVSTARS_PLUGIN_LICENSE="GNU GPLv2 or later")

ADD_SUBDIRECTORY( src )

=== plugins/Oculars/CMakeLists.txt ===
SET(OCULARS_STELMODULE_MAJOR "1")
SET(OCULARS_STELMODULE_MINOR "2")
SET(OCULARS_STELMODULE_PATCH "5")
SET(OCULARS_VERSION "${OCULARS_STELMODULE_MAJOR}.${OCULARS_STELMODULE_MINOR}.${OCULARS_STELMODULE_PATCH}")

ADD_DEFINITIONS(-DOCULARS_PLUGIN_VERSION="${OCULARS_VERSION}")
ADD_DEFINITIONS(-DOCULARS_PLUGIN_LICENSE="GNU GPLv2 or later")

ADD_SUBDIRECTORY( src )

=== plugins/PointerCoordinates/CMakeLists.txt ===
SET(POINTERCOORDINATES_MAJOR "0")
SET(POINTERCOORDINATES_MINOR "4")
SET(POINTERCOORDINATES_PATCH "0")
SET(POINTERCOORDINATES_VERSION "${POINTERCOORDINATES_MAJOR}.${POINTERCOORDINATES_MINOR}.${POINTERCOORDINATES_PATCH}")

ADD_DEFINITIONS(-DPOINTERCOORDINATES_PLUGIN_VERSION="${POINTERCOORDINATES_VERSION}")
ADD_DEFINITIONS(-DPOINTERCOORDINATES_PLUGIN_LICENSE="GNU GPLv2 or later")

ADD_SUBDIRECTORY( src )

=== plugins/Satellites/CMakeLists.txt ===
SET(SATELLITES_VERSION "0.13.6")

ADD_DEFINITIONS(-DSATELLITES_PLUGIN_VERSION="${SATELLITES_VERSION}")
ADD_DEFINITIONS(-DSATELLITES_PLUGIN_LICENSE="GNU GPLv2 or later")
# set this to 1 to compile Iridium parts. They have been disabled as on v0.20.2 due to Iridium flares no longer available.
# However, we should retain the code, just in case similar satellites will be developed.
SET(SATELLITES_PLUGIN_IRIDIUM 0)
ADD_DEFINITIONS(-DSATELLITES_PLUGIN_IRIDIUM=${SATELLITES_PLUGIN_IRIDIUM})

ADD_SUBDIRECTORY( src )

=== src/external/CMakeLists.txt ===
SET(glues_lib_SRCS
     glues_stel/source/glues_error.c
     glues_stel/source/glues_error.h
     glues_stel/source/glues.h
     glues_stel/source/libtess/dict.h
     glues_stel/source/libtess/dict.c
     glues_stel/source/libtess/dict-list.h
     glues_stel/source/libtess/geom.c
     glues_stel/source/libtess/geom.h
     glues_stel/source/libtess/memalloc.c
     glues_stel/source/libtess/memalloc.h
     glues_stel/source/libtess/mesh.c
     glues_stel/source/libtess/mesh.h
     glues_stel/source/libtess/normal.c
     glues_stel/source/libtess/normal.h
     glues_stel/source/libtess/priorityq.c
     glues_stel/source/libtess/priorityq.h
     glues_stel/source/libtess/priorityq-heap.h
     glues_stel/source/libtess/priorityq-heap.i
     glues_stel/source/libtess/priorityq-sort.h
     glues_stel/source/libtess/render.c
     glues_stel/source/libtess/render.h
     glues_stel/source/libtess/sweep.c
     glues_stel/source/libtess/sweep.h
     glues_stel/source/libtess/tess.c
     glues_stel/source/libtess/tess.h
     glues_stel/source/libtess/tessmono.c
     glues_stel/source/libtess/tessmono.h
)
add_library(glues_stel STATIC EXCLUDE_FROM_ALL ${glues_lib_SRCS})
target_include_directories(glues_stel PUBLIC glues_stel/source)
#link the GUI module for the GL headers
#our stripped version does not call any GL functions, but requires the GL types to be defined
target_link_libraries(glues_stel Qt${QT_VERSION_MAJOR}::Gui)
#turn off automoc, not needed here
set_target_properties(glues_stel PROPERTIES AUTOMOC 0)
SET_TARGET_PROPERTIES(glues_stel PROPERTIES FOLDER "src/external")

SET(zlib_SRCS
     zlib/adler32.c
     zlib/compress.c
     zlib/crc32.c
     zlib/crc32.h
     zlib/deflate.c
     zlib/deflate.h
     zlib/gzclose.c
     zlib/gzguts.h
     zlib/gzlib.c
     zlib/gzread.c
     zlib/gzwrite.c
     zlib/infback.c
     zlib/inffast.c
     zlib/inffast.h
     zlib/inffixed.h
     zlib/inflate.c
     zlib/inflate.h
     zlib/inftrees.c
     zlib/inftrees.h
     zlib/trees.c
     zlib/trees.h
     zlib/uncompr.c
     zlib/zconf.h
     zlib/zlib.h
     zlib/zutil.c
     zlib/zutil.h)

add_library(zlib_stel STATIC EXCLUDE_FROM_ALL ${zlib_SRCS})
target_include_directories(zlib_stel PUBLIC zlib)
#turn off automoc, not needed here
set_target_properties(zlib_stel PROPERTIES AUTOMOC 0)
SET_TARGET_PROPERTIES(zlib_stel PROPERTIES FOLDER "src/external")

################################# INDI ################################
IF(USE_PLUGIN_TELESCOPECONTROL)
    SET(PREFER_SYSTEM_INDILIB 1 CACHE BOOL
        "Use system-provided INDI instead of the bundled version")
    find_library(INDICLIENT_LIB indiclient)
    if(INDICLIENT_LIB AND PREFER_SYSTEM_INDILIB)
        MESSAGE(STATUS "Using system-provided indiclient at ${INDICLIENT_LIB}")
        add_library(indiclient UNKNOWN IMPORTED GLOBAL)
        set_target_properties(indiclient PROPERTIES
            IMPORTED_LOCATION "${INDICLIENT_LIB}")
    else()
        # Git repo is large, limit download to archive
        # Included CMakeLists.txt contains unrelated targets and dependencies of
        # them, therefore DOWNLOAD_ONLY and all the code below
        CPMAddPackage(NAME indiclient
            URL https://github.com/indilib/indi/archive/v1.8.5.zip
            URL_HASH SHA256=57b78afe6d338533e35725e94cf6a9e302e22348ab418811bd41997cddf13fd6
            VERSION 1.8.5
            DOWNLOAD_ONLY YES)

        # Installed version has /usr/include/libindi, move these headers to
        # such directory for a consistent #include
        file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/libindi)
        file(GLOB INDI_HEADERS "${indiclient_SOURCE_DIR}/libs/indibase/*.h")
        file(COPY ${INDI_HEADERS}
            DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/libindi)

        # Avoid bundling libnova too
        file(READ
            ${indiclient_SOURCE_DIR}/libs/indibase/inditelescope.h
            INDITELESCOPE_H)
        string(REGEX REPLACE
            "#include <libnova/julian_day.h>" "struct ln_date;"
            INDITELESCOPE_H "${INDITELESCOPE_H}")
        string(REGEX REPLACE
            "ln_lnlat_posn lnobserver { 0, 0 };" ""
            INDITELESCOPE_H "${INDITELESCOPE_H}")
        file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/libindi/inditelescope.h.new
            "${INDITELESCOPE_H}")
        configure_file(${CMAKE_CURRENT_BINARY_DIR}/libindi/inditelescope.h.new
            ${CMAKE_CURRENT_BINARY_DIR}/libindi/inditelescope.h COPYONLY)

        # Fix build in windows
        file(READ
            ${indiclient_SOURCE_DIR}/libs/indibase/indilogger.h
            INDILOGGER_H)
        string(REGEX REPLACE "#include <sys/time.h>"
            "#ifdef Q_OS_WIN\n#include <windows.h>\n#else\n#include <sys/time.h>\n#endif"
            INDILOGGER_H "${INDILOGGER_H}")
        file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/libindi/indilogger.h.new
            "${INDILOGGER_H}")
        configure_file(${CMAKE_CURRENT_BINARY_DIR}/libindi/indilogger.h.new
            ${CMAKE_CURRENT_BINARY_DIR}/libindi/indilogger.h COPYONLY)

        # https://devblogs.microsoft.com/cppblog/msvc-preprocessor-progress-towards-conformance/
        # This patch is upstreamed at
        # https://github.com/indilib/indi/pull/1728 so after version 1.9.8
        # shouldn't be needed
        file(GLOB INDILOCALE_H ${indiclient_SOURCE_DIR}/libs/locale_compat.h)
        if (INDILOCALE_H)
            file(READ ${indiclient_SOURCE_DIR}/libs/locale_compat.h INDILOCALE_H)
            string(REGEX REPLACE "L#s" "L\"\"#s" INDILOCALE_H "${INDILOCALE_H}")
            file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/libindi/locale_compat.h.new
                "${INDILOCALE_H}")
            configure_file(${CMAKE_CURRENT_BINARY_DIR}/libindi/locale_compat.h.new
                ${CMAKE_CURRENT_BINARY_DIR}/libindi/locale_compat.h COPYONLY)
            file(RENAME ${indiclient_SOURCE_DIR}/libs/locale_compat.h
                ${indiclient_SOURCE_DIR}/libs/locale_compat.h.bak)
        endif()

        set(INDI_SOVERSION "1")
        set(CMAKE_INDI_VERSION_MAJOR 1)
        set(CMAKE_INDI_VERSION_MINOR 8)
        set(CMAKE_INDI_VERSION_RELEASE 5)
        set(CMAKE_INDI_VERSION_STRING "${CMAKE_INDI_VERSION_MAJOR}.${CMAKE_INDI_VERSION_MINOR}.${CMAKE_INDI_VERSION_RELEASE}")
        set(INDI_VERSION ${CMAKE_INDI_VERSION_MAJOR}.${CMAKE_INDI_VERSION_MINOR}.${CMAKE_INDI_VERSION_RELEASE})
        set(DATA_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/share/indi/")
        configure_file(${indiclient_SOURCE_DIR}/config.h.cmake
            ${CMAKE_CURRENT_BINARY_DIR}/libindi/config.h )
        add_library(indiclient STATIC
            ${indiclient_SOURCE_DIR}/libs/lilxml.c
            ${indiclient_SOURCE_DIR}/base64.c
            ${indiclient_SOURCE_DIR}/libs/indibase/basedevice.cpp
            ${indiclient_SOURCE_DIR}/libs/indibase/baseclient.cpp
            ${indiclient_SOURCE_DIR}/libs/indibase/indiproperty.cpp
            ${indiclient_SOURCE_DIR}/libs/indibase/indistandardproperty.cpp
            ${indiclient_SOURCE_DIR}/libs/indicom.c)
        target_include_directories(indiclient
            PRIVATE
            ${CMAKE_CURRENT_BINARY_DIR}/libindi
            PUBLIC
            ${CMAKE_CURRENT_BINARY_DIR}
            ${indiclient_SOURCE_DIR}
            ${indiclient_SOURCE_DIR}/libs)
        target_link_libraries(indiclient ${ZLIB_LIBRARIES})
    endif()
ENDIF()

=== plugins/LensDistortionEstimator/src/CMakeLists.txt ===
FIND_PACKAGE(exiv2)

CPMFindPackage(NAME NLopt
               URL https://github.com/stevengj/nlopt/archive/refs/tags/v2.7.1.tar.gz
               URL_HASH SHA256=db88232fa5cef0ff6e39943fc63ab6074208831dc0031cf1545f6ecd31ae2a1a
               EXCLUDE_FROM_ALL yes
              )

INCLUDE_DIRECTORIES(
     .
     gui
     ${CMAKE_BINARY_DIR}/plugins/LensDistortionEstimator/src
     ${CMAKE_BINARY_DIR}/plugins/LensDistortionEstimator/src/gui
)

LINK_DIRECTORIES(${CMAKE_BINARY_DIR}/src)

SET(LensDistortionEstimator_SRCS
     LensDistortionEstimator.hpp
     LensDistortionEstimator.cpp
     gui/LensDistortionEstimatorDialog.hpp
     gui/LensDistortionEstimatorDialog.cpp
)

SET(LensDistortionEstimator_UIS
     gui/lensDistortionEstimatorDialog.ui
)

SET(LensDistortionEstimator_RES
     ../resources/LensDistortionEstimator.qrc
)

IF (${QT_VERSION_MAJOR} EQUAL "5")
     QT5_WRAP_UI(LensDistortionEstimator_UIS_H ${LensDistortionEstimator_UIS})
     QT5_ADD_RESOURCES(LensDistortionEstimator_RES_CXX ${LensDistortionEstimator_RES})
ELSE()
     QT_WRAP_UI(LensDistortionEstimator_UIS_H ${LensDistortionEstimator_UIS})
     QT_ADD_RESOURCES(LensDistortionEstimator_RES_CXX ${LensDistortionEstimator_RES})
ENDIF()

ADD_LIBRARY(LensDistortionEstimator-static STATIC ${LensDistortionEstimator_SRCS} ${LensDistortionEstimator_RES_CXX} ${LensDistortionEstimator_UIS_H})
TARGET_LINK_LIBRARIES(LensDistortionEstimator-static Qt${QT_VERSION_MAJOR}::Core Qt${QT_VERSION_MAJOR}::Widgets Qt${QT_VERSION_MAJOR}::OpenGL Qt${QT_VERSION_MAJOR}::Charts)
SET_TARGET_PROPERTIES(LensDistortionEstimator-static PROPERTIES OUTPUT_NAME "LensDistortionEstimator")
SET_TARGET_PROPERTIES(LensDistortionEstimator-static PROPERTIES COMPILE_FLAGS "-DQT_STATICPLUGIN")
if(exiv2_FOUND)
     MESSAGE(STATUS "Found exiv2 ${exiv2_VERSION_MAJOR}.${exiv2_VERSION_MINOR}.${exiv2_VERSION_PATCH}")
     TARGET_COMPILE_OPTIONS(LensDistortionEstimator-static PRIVATE "-DHAVE_EXIV2")
     IF(${exiv2_VERSION_MAJOR}.${exiv2_VERSION_MINOR}.${exiv2_VERSION_PATCH} VERSION_GREATER_EQUAL 0.28.1)
	     TARGET_LINK_LIBRARIES(LensDistortionEstimator-static Exiv2::exiv2lib)
     ELSE()
	     TARGET_LINK_LIBRARIES(LensDistortionEstimator-static exiv2lib)
     ENDIF()
endif()

TARGET_COMPILE_OPTIONS(LensDistortionEstimator-static PRIVATE "-DHAVE_NLOPT")
IF(NLopt_ADDED)
	ADD_DEPENDENCIES(LensDistortionEstimator-static generate-cpp)
	TARGET_INCLUDE_DIRECTORIES(LensDistortionEstimator-static
	                           PRIVATE ${CPM_PACKAGE_NLopt_BINARY_DIR} ${CPM_PACKAGE_NLopt_SOURCE_DIR}/src/api)
	TARGET_LINK_LIBRARIES(LensDistortionEstimator-static nlopt)
ELSE()
	# NLOPT_LIBRARIES variable is not set by CPM (unlike find_package; see
	# https://github.com/cpm-cmake/CPM.cmake/issues/132), and the imported target
	# may appear to be NLopt::nlopt or NLopt::nlopt_cxx, and using any one of these
	# is incompatible with versions of nlopt where the other would be found. So
	# let's check which one we should use.
	IF(NLopt_DIR MATCHES "nlopt_cxx$")
		set(NLOPT_LIBRARIES NLopt::nlopt_cxx)
	ELSEIF(NLopt_DIR MATCHES "nlopt$")
		set(NLOPT_LIBRARIES NLopt::nlopt)
	ENDIF()
	TARGET_LINK_LIBRARIES(LensDistortionEstimator-static ${NLOPT_LIBRARIES})
ENDIF()

ADD_DEPENDENCIES(AllStaticPlugins LensDistortionEstimator-static)

SET_TARGET_PROPERTIES(LensDistortionEstimator-static PROPERTIES FOLDER "plugins/LensDistortionEstimator")

=== plugins/Satellites/src/CMakeLists.txt ===
INCLUDE_DIRECTORIES(
     .
     gsatellite
     gui
     ${CMAKE_BINARY_DIR}/plugins/Satellites/src
     ${CMAKE_BINARY_DIR}/plugins/Satellites/src/gui
)

LINK_DIRECTORIES(${CMAKE_BINARY_DIR}/src)

SET(Satellites_SRCS
     gsatellite/gException.hpp
     gsatellite/gSatTEME.cpp
     gsatellite/gSatTEME.hpp
     gsatellite/mathUtils.hpp
     gsatellite/gTime.cpp
     gsatellite/gTime.hpp
     gsatellite/gTimeSpan.cpp
     gsatellite/sgp4ext.cpp
     gsatellite/sgp4ext.h
     gsatellite/sgp4io.cpp
     gsatellite/sgp4io.h
     gsatellite/sgp4unit.cpp
     gsatellite/sgp4unit.h
     gsatellite/stdsat.h

     gSatWrapper.hpp
     gSatWrapper.cpp
     Satellite.hpp
     Satellite.cpp
     Satellites.hpp
     Satellites.cpp
     SatellitesListModel.hpp
     SatellitesListModel.cpp
     SatellitesListFilterModel.hpp
     SatellitesListFilterModel.cpp
     gui/SatellitesDialog.hpp
     gui/SatellitesDialog.cpp
     gui/SatellitesImportDialog.hpp
     gui/SatellitesImportDialog.cpp
     gui/SatellitesFilterDialog.hpp
     gui/SatellitesFilterDialog.cpp
     gui/SatellitesCommDialog.hpp
     gui/SatellitesCommDialog.cpp
)

SET(SatellitesDialog_UIS
     gui/satellitesDialog.ui
     gui/satellitesImportDialog.ui
     gui/satellitesFilterDialog.ui
     gui/satellitesCommDialog.ui
)

SET(Satellites_RES ../resources/Satellites.qrc)
IF (${QT_VERSION_MAJOR} EQUAL "5")
     QT5_WRAP_UI(SatellitesDialog_UIS_H ${SatellitesDialog_UIS})
     QT5_ADD_RESOURCES(Satellites_RES_CXX ${Satellites_RES})
ELSE()
     QT_WRAP_UI(SatellitesDialog_UIS_H ${SatellitesDialog_UIS})
     QT_ADD_RESOURCES(Satellites_RES_CXX ${Satellites_RES})
ENDIF()

IF(ENABLE_TESTING)
     ADD_SUBDIRECTORY(test)
ENDIF(ENABLE_TESTING)

ADD_LIBRARY(Satellites-static STATIC ${Satellites_SRCS} ${Satellites_RES_CXX} ${SatellitesDialog_UIS_H})
IF(ENABLE_XLSX AND (${SATELLITES_PLUGIN_IRIDIUM} EQUAL "1"))
    TARGET_LINK_LIBRARIES(Satellites-static Qt${QT_VERSION_MAJOR}::Core
	    Qt${QT_VERSION_MAJOR}::Network Qt${QT_VERSION_MAJOR}::Widgets
	    Qt${QT_VERSION_MAJOR}::GuiPrivate QXlsx::QXlsx)
ELSE()
    TARGET_LINK_LIBRARIES(Satellites-static Qt${QT_VERSION_MAJOR}::Core
	    Qt${QT_VERSION_MAJOR}::Network Qt${QT_VERSION_MAJOR}::Widgets
	    Qt${QT_VERSION_MAJOR}::GuiPrivate)
ENDIF()
# The library target "Satellites-static" has a default OUTPUT_NAME of "Satellites-static", so change it.
SET_TARGET_PROPERTIES(Satellites-static PROPERTIES OUTPUT_NAME "Satellites")
IF(MSVC)
     SET_TARGET_PROPERTIES(Satellites-static PROPERTIES COMPILE_FLAGS "-DQT_STATICPLUGIN")
ELSE()
     SET_TARGET_PROPERTIES(Satellites-static PROPERTIES COMPILE_FLAGS "-DQT_STATICPLUGIN -Wno-unused-parameter")
ENDIF()
ADD_DEPENDENCIES(AllStaticPlugins Satellites-static)

SET_TARGET_PROPERTIES(Satellites-static PROPERTIES FOLDER "plugins/Satellites")

=== plugins/TelescopeControl/src/gui/CMakeLists.txt ===
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)

SET(TelescopeControl_GUI_UIS
    slewDialog.ui
    telescopeDialog.ui
    telescopeConfigurationDialog.ui
    storedPointsDialog.ui
    )

IF (${QT_VERSION_MAJOR} EQUAL "5")
     QT5_WRAP_UI(TelescopeControl_GUI_UIS_H ${TelescopeControl_GUI_UIS})
ELSE()
     QT_WRAP_UI(TelescopeControl_GUI_UIS_H ${TelescopeControl_GUI_UIS})
ENDIF()

add_library(TelescopeControl_gui STATIC
    SlewDialog.hpp
    SlewDialog.cpp
    TelescopeDialog.hpp
    TelescopeDialog.cpp
    TelescopeConfigurationDialog.hpp
    TelescopeConfigurationDialog.cpp
    StoredPointsDialog.hpp
    StoredPointsDialog.cpp
    ${TelescopeControl_GUI_UIS_H}
    )

target_link_libraries(TelescopeControl_gui
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::Network
    Qt${QT_VERSION_MAJOR}::Gui
    TelescopeControl_common
    TelescopeControl_INDI    
    )

IF(WIN32)
target_link_libraries(TelescopeControl_gui
    TelescopeControl_ASCOM
    )
ENDIF(WIN32)

SET_TARGET_PROPERTIES(TelescopeControl_gui PROPERTIES FOLDER "plugins/TelescopeControl")

=== debian/changelog ===
stellarium (24.2-1+rpi1) trixie-staging; urgency=medium

  * Remove armhf from qtwebengine architecture list.

 -- Peter Michael Green <plugwash@raspbian.org>  Sun, 30 Jun 2024 09:35:11 +0000

stellarium (24.2-1) unstable; urgency=medium

  * New upstream version 24.2

 -- Tomasz Buchert <tomasz@debian.org>  Sun, 23 Jun 2024 22:22:53 +0200

=== debian/control ===
Source: stellarium
Maintainer: Debian Astro Maintainers <debian-astro-maintainers@lists.alioth.debian.org>
Uploaders: Tomasz Buchert <tomasz@debian.org>
Section: science
Priority: optional
Build-Depends: cmake,
               debhelper (>= 13),
               debhelper-compat (= 13),
               doxygen,
               libexiv2-dev,
               libindi-dev,
               libnlopt-cxx-dev,
               libnova-dev,
               libqt5charts5-dev (>= 5.11.3),
               libqt5opengl5-dev (>= 5.4),
               libqt5qxlsx-dev,
               libqt5serialport5-dev (>= 5.4),
               mesa-common-dev,
               qtbase5-dev (>= 5.4),
               qtbase5-private-dev,
               qtdeclarative5-dev (>= 5.4),
               qtdeclarative5-dev-tools (>= 5.4),
               qtmultimedia5-dev (>= 5.4),
               qtpositioning5-dev (>= 5.4),
               qtscript5-dev (>= 5.4),
               qttools5-dev (>= 5.4),
               qttools5-dev-tools (>= 5.4),
               qtwebengine5-dev (>= 5.15) [amd64 arm64 i386 mips64el],
               zlib1g-dev
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/debian-astro-team/stellarium
Vcs-Git: https://salsa.debian.org/debian-astro-team/stellarium.git
Homepage: https://www.stellarium.org

Package: stellarium
Architecture: any
Depends: stellarium-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: real-time photo-realistic sky generator
 Stellarium renders 3D photo-realistic skies in real-time. With Stellarium, you
 really see what you can see with your eyes, binoculars or a small telescope.
 .
 Some features:
  - default star catalogue with over 600 thousand stars,
  - information about the brightest stars (spectral type, distance, etc.),
  - downloadable star catalogue extensions, for up to 210 million stars,
  - all New General Catalogue (NGC) objects,
  - images of almost all Messier objects and the Milky Way,
  - real time positions of the planets and their satellites,
  - 13 different cultures with their constellations,
  - artistic illustrations of the 88 Western constellations,
  - very realistic atmosphere, sunrise and sunset,
  - 7 panoramic landscapes (more can be made or downloaded from the website),
  - scripting with ECMAScript,
  - plug-in support: Stellarium comes with 8 plug-ins by default, including:
  - artificial satellites plug-in (updated from an on-line TLE database),
  - ocular simulation plug-in (shows how objects look like in a given ocular),
  - Solar System editor plug-in (imports comet and asteroid data from the MPC),
  - telescope control plug-in (Meade LX200 and Celestron NexStar compatible).
 .
 Stellarium should not be used for very high accurate calculation or ephemerids
 like eclipse predictions. However, it is the ideal program to prepare an
 observation evening with naked eye, binocular, or small telescope.

Package: stellarium-data
Architecture: all
Depends: fonts-dejavu-core, ${misc:Depends}
Recommends: stellarium (= ${source:Version})
Description: Stellarium data files
 Stellarium renders 3D photo-realistic skies in real-time. With Stellarium, you
 really see what you can see with your eyes, binoculars or a small telescope.
 .
 This package contains data files required by Stellarium. They include
 textures, star catalogues and translations.
